#include "header\GBA.h"
#include "header\BG.h"
#include "header\Timer.h"
#include "header\DMA.h"
#include "header\IRQ.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\Blend.h"

#include "lib.h"
#include "iwram.h"
#include "irq.h"
#include "syscall.h"

#include "resource\data.h"
//#include "resource\BitMapFont.h"
#include "resource\BGFont.h"
#include "resource\background.map.h"
#include "resource\bghide.map.h"

#include <stdlib.h>

//const int __gba_multiboot;	//GBANp

//BG1    XvCg̕\B
//BG2    
//BG3    wi
//Sprite jbgƒe


#define TRUE  (1)
#define FALSE (0)

#define UNIT_MAX_CNT 20
#define EMEMY_MAX_CNT 8
#define MY_BULLET_MAX_CHAGE_TIMING 16

#define MY_BULLET_MAX_CNT 4
#define ENEMY_BULLET_MAX_CNT 10
#define HIT_MAX_CNT (MY_BULLET_MAX_CNT + ENEMY_BULLET_MAX_CNT)

//---------------------------------------------------------------------------
u8 BG1Map;
u8 BG1Chr;
u8 BG2Map;
u8 BG2Chr;
u8 BG3Map;
u8 BG3Chr;

u16 Score;
u16 Left;
u16 GameEndFlag;

u16 EnemyDispCnt;
u16 EnemyDispBulletCnt;
u16 MyBulletDispCnt;
u16 MyBulletChargTiming;

u16 UnitAcrossVariable1;	//^XNԂ̕ϐ̎󂯓np
u16 UnitAcrossVariable2;

u8 HitSrcCnt;
u8 HitDstCnt;
//---------------------------------------------------------------------------
typedef struct {
	u8  regFlag;		//^XN̓o^(TRUE or FALSE)
	u8  x;
	u8  y;
	u8  cx;
	u8  cy;
	u16 SprNo;
	u16 SprTile;
	u16 SprSize;
	u16 SprForm;
	u8  data;
	void (*pAction)(u8);
	void (*pDestory)(u8);
}ST_UNIT;

ST_UNIT   UNIT[UNIT_MAX_CNT];


typedef struct {
	u8 regFlag;
	u8 num;
	u8 x;
	u8 y;
	u8 cx;
	u8 cy;
	void (*pDestory)(u8);
}ST_HIT;

ST_HIT    HIT_SRC[HIT_MAX_CNT];
ST_HIT    HIT_DST[HIT_MAX_CNT];

//---------------------------------------------------------------------------
void Init();
void InitBG();
void InitSprite();

void InitUnit();
void InitHit();

//----------------------
void ExecHit();
void AddHitSrc(u8);
void AddHitDst(u8);

//----------------------
void UnitControl();
void UnitMove(u8);

void UnitRegist(void());
void UnitRegistMyShip(u8);
void UnitRegistMyBullet(u8);
void UnitRegistEnemyShip(u8);
void UnitRegistEnemyBullet(u8);
void UnitRegistScore(u8);
void UnitRegistLeft(u8);

void UnitAction();
void UnitActionMyShip(u8);
void UnitActionMyBullet(u8);
void UnitActionEnemyShip(u8);
void UnitActionEnemyBullet(u8);
void UnitActionScore(u8);
void UnitActionLeft(u8);

void UnitDestroy(u8);
void UnitDestroyMyShip(u8);
void UnitDestroyMyBullet(u8);
void UnitDestroyEnemyShip(u8);
void UnitDestroyEnemyBullet(u8);
void UnitDestroyScore(u8);
void UnitDestroyLeft(u8);
//----------------------

void SpriteRegist(u8);
//---------------------------------------------------------------------------
int main(void)
{
	Init();
	InitBG();
	InitSprite();
	InitUnit();
	InitHit();

	SetMode(MODE_0 | BG1_ENABLE | BG2_ENABLE | BG3_ENABLE
	               | OBJ_ENABLE | OBJ_MAP_2D);

	BGDrawStr(BG2Map, 8, 10, "Push A Button!");
	WaitKey(KEY_A);			//SrandĂ܂

	BGDrawCls(BG2Map, 0x0000);
	BGDrawStr(BG2Map,  3, 17, "Score");
	BGDrawStr(BG2Map, 23, 17, "Left" );

	//@ƃXRA\̃^XN𐶐
	UnitRegist((void*)UnitRegistMyShip);
	UnitRegist((void*)UnitRegistScore );
	UnitRegist((void*)UnitRegistLeft  );
	
	for(;;)
	{
		WaitForVsync();
		
		UnitControl();		//Q[̎吧iG̏oj
		UnitAction();		//^XN̈ď

		ExecHit();			//蔻
		InitHit();

		if(GameEndFlag == TRUE)
			break;
	}

	for(;;)
	{
		BGDrawStr(BG2Map, 8, 10, "Game Over");
	}
	return 0;
}
//---------------------------------------------------------------------------
void Init()
{
	Score = 0;
	Left  = 2;

	GameEndFlag = FALSE;

	EnemyDispCnt         = 0;
	EnemyDispBulletCnt   = 0;
	MyBulletDispCnt      = 0;
	MyBulletChargTiming  = 0;
}
//---------------------------------------------------------------------------
void InitBG()
{
	//BG1 XvCg\B
	//BG2 
	//BG3 wi

	BG1Map = 0;
	BG2Map = 1;
	BG3Map = 2;

	BG1Chr = 2;
	BG2Chr = 1;
	BG3Chr = 2;

	REG_BG1CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG1Chr) | BG_MAPBASE(BG1Map) | 1);
	REG_BG2CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG2Chr) | BG_MAPBASE(BG2Map) | 2);
	REG_BG3CNT = (BG_SIZEA_256_256    | BG_COLOR_16        |
				  BG_CHARBASE(BG3Chr) | BG_MAPBASE(BG3Map) | 3);

	//Palette
	BGSetPal16(0, (u16*)BGFont_palette);
	BGSetPal16(1, (u16*)EtfsGetDataOffset(_BACKGROUND_IMG_PAL_OFFSET));

	//ChrData
	BGSetChrData(BG2Chr, (u16*)BGFont_data, BGFont_DATA_SIZE);
	BGSetChrData(BG3Chr, (u16*)EtfsGetDataOffset(_BACKGROUND_IMG_BIN_OFFSET), _BACKGROUND_IMG_BIN_SIZE);

	//MapData
	BGSetMapData(BG1Map, (u16*)bghideData,     bghideSize*4    );
	BGSetMapData(BG3Map, (u16*)backgroundData, backgroundSize*4);
	BGSetPalMap(BG1Map, bghideSize*4,     1);
	BGSetPalMap(BG3Map, backgroundSize*4, 1);
}
//---------------------------------------------------------------------------
void InitSprite()
{
	SpriteInitialize();
	SpriteSetPal16((u16*)EtfsGetDataOffset(_SPRITE_IMG_PAL_OFFSET));
	SpriteSetData ((u16*)EtfsGetDataOffset(_SPRITE_IMG_BIN_OFFSET), _SPRITE_IMG_BIN_SIZE);
}
//---------------------------------------------------------------------------
void InitUnit()
{
	u8 i;
	for(i=0; i<UNIT_MAX_CNT; i++)
	{
		UNIT[i].regFlag  = FALSE;
		UNIT[i].x        = 0;
		UNIT[i].y        = 0;
		UNIT[i].cx       = 0;
		UNIT[i].cy       = 0;
		UNIT[i].SprNo    = 0;
		UNIT[i].SprTile  = 0;
		UNIT[i].SprSize  = 0;
		UNIT[i].SprForm  = 0;
		UNIT[i].pAction  = NULL;
		UNIT[i].data     = 0;
	}
}
//---------------------------------------------------------------------------
void InitHit()
{
	u8 i;
	for(i=0; i<HIT_MAX_CNT; i++)
	{
		HIT_SRC[i].regFlag  = FALSE;
		HIT_SRC[i].num      = 0;
		HIT_SRC[i].x        = 0;
		HIT_SRC[i].y        = 0;
		HIT_SRC[i].cx       = 0;
		HIT_SRC[i].cy       = 0;
		HIT_SRC[i].pDestory = NULL;

		HIT_DST[i].regFlag  = FALSE;
		HIT_DST[i].num      = 0;
		HIT_DST[i].x        = 0;
		HIT_DST[i].y        = 0;
		HIT_DST[i].cx       = 0;
		HIT_DST[i].cy       = 0;
		HIT_DST[i].pDestory = NULL;
	}
	HitSrcCnt = 0;
	HitDstCnt = 0;
}
//---------------------------------------------------------------------------
void SpriteRegist(u8 num)
{
	SpriteSetSize(UNIT[num].SprNo, UNIT[num].SprSize, UNIT[num].SprForm, SP_COLOR_16);
	SpriteSetChr (UNIT[num].SprNo, UNIT[num].SprTile);
	SpriteSetPriority(UNIT[num].SprNo, 2);
}
//---------------------------------------------------------------------------
void UnitMove(u8 num)
{
	SpriteMove(UNIT[num].SprNo, UNIT[num].x, UNIT[num].y);
}
//---------------------------------------------------------------------------
void UnitControl()
{
	//GD̏o
	//rand()%80 == 0 && 
	if(EnemyDispCnt < EMEMY_MAX_CNT)
	{
		UnitRegist((void*)UnitRegistEnemyShip);
	}
}
//---------------------------------------------------------------------------
void UnitAction()
{
	u8 i;
	for(i=0; i<UNIT_MAX_CNT; i++)
	{
		if(UNIT[i].regFlag == TRUE)
		{
			UNIT[i].pAction(i);
			UnitMove(i);
		}
	}
}
//---------------------------------------------------------------------------
void UnitDestroy(u8 num)
{
	UNIT[num].regFlag  = FALSE;
	UNIT[num].pAction  = NULL;
	UNIT[num].pDestory = NULL;
	UNIT[num].x        = 240;
	UNIT[num].y        = 160;
	UnitMove(num);
	SpriteSetVertical(UNIT[num].SprNo, 0);
}
//---------------------------------------------------------------------------
void UnitDestroyMyShip(u8 num)
{
	GameEndFlag = TRUE;
	UnitDestroy(num);
}
//---------------------------------------------------------------------------
void UnitDestroyMyBullet(u8 num)
{
	MyBulletDispCnt--;
	UnitDestroy(num);
}
//---------------------------------------------------------------------------
void UnitDestroyEnemyShip(u8 num)
{
	EnemyDispCnt--;
	UnitDestroy(num);
}
//---------------------------------------------------------------------------
void UnitDestroyEnemyBullet(u8 num)
{
	EnemyDispBulletCnt--;
	UnitDestroy(num);
}
//---------------------------------------------------------------------------
void UnitRegist(void pRegUnit())
{
	u8 i;
	for(i=0; i<UNIT_MAX_CNT; i++)
	{
		if(UNIT[i].regFlag == FALSE)
		{
			pRegUnit(i);
			SpriteRegist(i);
			return;
		}
	}
	dprintf("too many unit\n");
}
//---------------------------------------------------------------------------
void UnitRegistMyShip(u8 num)
{
	UNIT[num].regFlag  = TRUE;
	UNIT[num].pAction  = &UnitActionMyShip;
	UNIT[num].pDestory = &UnitDestroyMyShip;
	UNIT[num].x        = 240/2 - 24/2;
	UNIT[num].y        = 18;
	UNIT[num].cx       = 24;
	UNIT[num].cy       = 8;
	UNIT[num].SprNo    = num;
	UNIT[num].SprTile  = 0;
	UNIT[num].SprSize  = SP_SIZE_16;
	UNIT[num].SprForm  = SP_WIDE;
	UNIT[num].data     = 0;
}
//---------------------------------------------------------------------------
void UnitRegistEnemyShip(u8 num)
{
	u8 appFlag = rand()%2;

	UNIT[num].regFlag  = TRUE;
	UNIT[num].pAction  = &UnitActionEnemyShip;
	UNIT[num].pDestory = &UnitDestroyEnemyShip;
	UNIT[num].x        = appFlag ? 240 : 0;
	UNIT[num].y        = 64 + rand()%11 * 5;
	UNIT[num].cx       = 24;
	UNIT[num].cy       = 8;
	UNIT[num].SprNo    = num;
	UNIT[num].SprTile  = 4;
	UNIT[num].SprSize  = SP_SIZE_16;
	UNIT[num].SprForm  = SP_WIDE;
	UNIT[num].data     = appFlag;	//E or 

	if(!appFlag)
	{								//̕ύX
		SpriteSetVertical(num,1);
	}

	EnemyDispCnt++;
}
//---------------------------------------------------------------------------
void UnitRegistMyBullet(u8 num)
{
	u16 key = *KEYS ^ 0x3ff;
	u16 x;

	if(key & KEY_A) x = UnitAcrossVariable1;
    else            x = UnitAcrossVariable1 + 24; //KEY_B̏ꍇ

	UNIT[num].regFlag  = TRUE;
	UNIT[num].pAction  = &UnitActionMyBullet;
	UNIT[num].pDestory = &UnitDestroyMyBullet;
	UNIT[num].x        = x;
	UNIT[num].y        = UnitAcrossVariable2;
	UNIT[num].cx       = 8;
	UNIT[num].cy       = 8;
	UNIT[num].SprNo    = num;
	UNIT[num].SprTile  = 8;
	UNIT[num].SprSize  = SP_SIZE_8;
	UNIT[num].SprForm  = SP_SQUARE;
	UNIT[num].data     = 0;

	MyBulletDispCnt++;
}
//---------------------------------------------------------------------------
void UnitRegistEnemyBullet(u8 num)
{
	UNIT[num].regFlag  = TRUE;
	UNIT[num].pAction  = &UnitActionEnemyBullet;
	UNIT[num].pDestory = &UnitDestroyEnemyBullet;
	UNIT[num].x        = UnitAcrossVariable1;
	UNIT[num].y        = UnitAcrossVariable2;
	UNIT[num].cx       = 8;
	UNIT[num].cy       = 8;
	UNIT[num].SprNo    = num;
	UNIT[num].SprTile  = 9;
	UNIT[num].SprSize  = SP_SIZE_8;
	UNIT[num].SprForm  = SP_SQUARE;
	UNIT[num].data     = 0;

	EnemyDispBulletCnt++;
}
//---------------------------------------------------------------------------
void UnitActionMyShip(u8 num)
{
	u16 key = *KEYS ^ 0x3ff;

	//ړ͈
	if(key & KEY_LEFT  && UNIT[num].x >  28) UNIT[num].x--;
	if(key & KEY_RIGHT && UNIT[num].x < 182) UNIT[num].x++;

	//e̔
	if(    (key & KEY_A || key & KEY_B)
		&& (MyBulletDispCnt     <  MY_BULLET_MAX_CNT)
		&& (MyBulletChargTiming >= MY_BULLET_MAX_CHAGE_TIMING) )
	{
		MyBulletChargTiming = 0;
		UnitAcrossVariable1 = UNIT[num].x;
		UnitAcrossVariable2 = UNIT[num].y;
		UnitRegist((void*)UnitRegistMyBullet);
	}

	//e̔˃`[W
	if(MyBulletChargTiming < MY_BULLET_MAX_CHAGE_TIMING)
	{
		MyBulletChargTiming++;
	}
}
//---------------------------------------------------------------------------
void UnitActionEnemyShip(u8 num)
{
	//ړ
	if(UNIT[num].data) UNIT[num].x--;
	else               UNIT[num].x++;

	//G̒e
	if(    (rand() % 100 == 0)
	    && (EnemyDispBulletCnt < ENEMY_BULLET_MAX_CNT) )
	{
		UnitAcrossVariable1 = UNIT[num].x;
		UnitAcrossVariable2 = UNIT[num].y;
		UnitRegist((void*)UnitRegistEnemyBullet);
	}

	//I
	if(UNIT[num].x == 0 || UNIT[num].x == 240+24)
	{
		UnitDestroyEnemyShip(num);
	}

	AddHitDst(num);
}
//---------------------------------------------------------------------------
void UnitActionMyBullet(u8 num)
{
	if(UNIT[num].y < 120)
	{
		UNIT[num].y++;
		AddHitSrc(num);
	}
	else
	{
		UnitDestroyMyBullet(num);
	}
}
//---------------------------------------------------------------------------
void UnitActionEnemyBullet(u8 num)
{
	if(UNIT[num].y > 24)
	{
		UNIT[num].y--;
	}
	else
	{
		UnitDestroyEnemyBullet(num);
	}
}
//---------------------------------------------------------------------------
void ExecHit()
{
	u8 s,d;

	//eƓGjbgɓ`FbN
	for(s=0; s<HitSrcCnt; s++)
	{
		for(d=0; d<HitDstCnt; d++)
		{
			if(HIT_DST[d].regFlag == FALSE)
			{
				continue;
			}
			//蔻
			if(    (HIT_SRC[s].y < HIT_DST[d].y + HIT_DST[d].cy)
			    && (HIT_DST[d].y < HIT_SRC[s].y + HIT_SRC[s].cy) )
			{
				if(    (HIT_SRC[s].x < HIT_DST[d].x + HIT_DST[d].cx)
				    && (HIT_DST[d].x < HIT_SRC[s].x + HIT_SRC[s].cx) )
				{
					//݂̃^XNł
					HIT_SRC[s].pDestory(HIT_SRC[s].num);
					HIT_DST[d].pDestory(HIT_DST[d].num);
					HIT_DST[d].regFlag = FALSE;
					HIT_SRC[s].regFlag = FALSE;
					Score += 100;
					d = HitDstCnt;
				}
			}
		}
	}
}
//---------------------------------------------------------------------------
void AddHitSrc(u8 num)
{
	if(HitSrcCnt >= HIT_MAX_CNT)
	{
		dprintf("too many HitSrcCnt\n");
		return;
	}

	HIT_SRC[HitSrcCnt].regFlag  = TRUE;
	HIT_SRC[HitSrcCnt].num      = num;
	HIT_SRC[HitSrcCnt].x        = UNIT[num].x;
	HIT_SRC[HitSrcCnt].y        = UNIT[num].y;
	HIT_SRC[HitSrcCnt].cx       = UNIT[num].cx;
	HIT_SRC[HitSrcCnt].cy       = UNIT[num].cy;
	HIT_SRC[HitSrcCnt].pDestory = UNIT[num].pDestory;

	HitSrcCnt++;
}
//---------------------------------------------------------------------------
void AddHitDst(u8 num)
{
	if(HitDstCnt >= HIT_MAX_CNT)
	{
		dprintf("too many HitDstCnt\n");
		return;
	}

	HIT_DST[HitDstCnt].regFlag  = TRUE;
	HIT_DST[HitDstCnt].num      = num;
	HIT_DST[HitDstCnt].x        = UNIT[num].x;
	HIT_DST[HitDstCnt].y        = UNIT[num].y;
	HIT_DST[HitDstCnt].cx       = UNIT[num].cx;
	HIT_DST[HitDstCnt].cy       = UNIT[num].cy;
	HIT_DST[HitDstCnt].pDestory = UNIT[num].pDestory;

	HitDstCnt++;
}
//---------------------------------------------------------------------------
void UnitRegistScore(u8 num)
{
	UNIT[num].regFlag  = TRUE;
	UNIT[num].pAction  = &UnitActionScore;
	UNIT[num].pDestory = &UnitDestroyScore;
	UNIT[num].x        = 0;
	UNIT[num].y        = 0;
	UNIT[num].cx       = 240;
	UNIT[num].cy       = 160;
	UNIT[num].SprNo    = num;
	UNIT[num].SprTile  = 0;
	UNIT[num].SprSize  = 0;
	UNIT[num].SprForm  = 0;
	UNIT[num].data     = 0;
}
//---------------------------------------------------------------------------
void UnitActionScore(u8 num)
{
	u8 DispScore[256];
	bprintf(DispScore, "%5d", Score);

	BGDrawStr(BG2Map,  3, 18, DispScore);
}
//---------------------------------------------------------------------------
void UnitDestroyScore(u8 num)
{
}
//---------------------------------------------------------------------------
void UnitRegistLeft(u8 num)
{
	UNIT[num].regFlag  = TRUE;
	UNIT[num].pAction  = &UnitActionLeft;
	UNIT[num].pDestory = &UnitDestroyLeft;
	UNIT[num].x        = 0;
	UNIT[num].y        = 0;
	UNIT[num].cx       = 240;
	UNIT[num].cy       = 160;
	UNIT[num].SprNo    = num;
	UNIT[num].SprTile  = 0;
	UNIT[num].SprSize  = 0;
	UNIT[num].SprForm  = 0;
	UNIT[num].data     = 0;
}
//---------------------------------------------------------------------------
void UnitActionLeft(u8 num)
{
	u8 DispLeft[256];
	bprintf(DispLeft, "%2d", Left);

	BGDrawStr(BG2Map,  25, 18, DispLeft);
}
//---------------------------------------------------------------------------
void UnitDestroyLeft(u8 num)
{
}
